#include	"defs.h"
#include	"fmtregs.h"


char *roman_numerals(n, c)
{
	int u, v = 1000, j = 0, k;
	char *numeral = c == LOWER ? "mdclxvi" : "MDCLXVI";
	static char roman[128];
	char *rp = roman;

	if (n < 0) {
		*rp++ = '-';
		n = -n;
	}
	if (n == 0)
		*rp++ = '0';
	loop {
		for ( ; n >= v; n -= v)
			*rp++ = numeral[j];
		if (n <= 0)
			break;
		k = j;
		u = v / 5;
		if (++k & 01) {
			k++;
			u >>= 1;
		}
		if (n + u >= v) {
			*rp++ = numeral[k];
			n += u;
		} else
			v /= ((++j & 01) ? 2 : 5);
	}
	*rp = EOS;
	return roman;
}

char *alpha_num(n, c)
{
	char caseletter = c == LOWER ? 'a' : 'A', rev[128];
	static char alpha[128];
	char *rp = rev, *ap = alpha;

	if (n < 0) {
		*ap++ = '-';
		n = -n;
	}
	if (n == 0)
		*rp++ = '0';
	for ( ; n > 0; n /= 26)
		*rp++ = --n % 26 + caseletter;
	while (--rp >= rev)
		*ap++ = *rp;
	*ap = EOS;
	return alpha;
}
