#include	"defs.h"
#include	"input.h"
#include	"string.h"
#include	"name.h"
#include	"alloc.h"
#include	"print.h"

#define	FFAMSIZE	4

typedef char	*ffam[FFAMSIZE];

typedef struct F {
	ffam	fam;
	struct F *next;
} ufont;

static ffam famfonts[] = {
	{ "T", "TI", "TB", "TX" },		/* Times */
	{ "H", "HI", "HB", "HX" },		/* Helvetica */
	{ "C", "CI", "CB", "CX" },		/* Courier */
	{ "PA","PAI","PAB","PAX" },		/* Palatino */
	{ "S", NULLSTR,NULLSTR,NULLSTR },	/* Symbol */
	{ "ZC",NULLSTR,NULLSTR,NULLSTR },	/* ZapfChancery-MediumItalic */
	{ "ZD",NULLSTR,NULLSTR,NULLSTR },	/* ZapfDingbats */
	{ NULLSTR }
};

static ufont	*userfonts = (ufont *)0;

static	char	*in_family();


char *lookup_font(ft)
register char *ft;
{
	register char *f;
	register ffam *ffp;
	register ufont *ufp;

	for (ufp = userfonts; ufp; ufp = ufp->next)
		if (f = in_family(ufp->fam, ft))
			return f;
	for (ffp = famfonts; **ffp; ffp++)
		if (f = in_family(*ffp, ft))
			return f;
	return NULLSTR;
}


char *lookup_famfont(ft, fam)
char ft;
register char *fam;
{
	register ffam *ffp;
	register ufont *ufp;
	int index;
	static char *famfts = "RIBX";

	index = strchr(famfts, ft) - famfts;
	if (index < 0 || index > 3)	/* impossible!!! */
		return NULLSTR;
	for (ufp = userfonts; ufp; ufp = ufp->next)
		if (in_family(ufp->fam, fam))
			return ufp->fam[index];
	for (ffp = famfonts; *ffp; ffp++)
		if (in_family(*ffp, fam))
			return (*ffp)[index];
	return NULLSTR; 
}


static char *in_family(fam, f)
ffam fam;
char *f;
{
	register i;
	register char **ff = fam;

	for (i = 0; i < FFAMSIZE && *ff; i++, ff++)
		if (streq(*ff, f))
			return *ff;
	return NULLSTR;
}


void add_font()			/* .font abb name [abb name]{1..3} */
{
	register ufont *ufp;
	char *ft, abb[128];
	int i, ft_len;
	static char face_let[4] = { '\0', 'I', 'B', 'X' };

	if (peeknb() == EOS)
		RET_WARN("no arguments given to '.font'");
	ft = trim(getwd());
	if (*ft == EOS || peeknb() == EOS)
		RET_WARN("bad arguments given to '.font'");
	ufp = (ufont *)alloc(sizeof(*ufp), "font name");
	for (i = 0; i < FFAMSIZE; i++) {
		if (peeknb() == EOS)
			break;
		if (i == 0) {
			ufp->fam[i] = mk_string(ft);
			ft_len = strlen(strcpy(abb, ft));
		} else {
			abb[ft_len] = face_let[i];
			abb[ft_len+1] = '\0';
			ufp->fam[i] = mk_string(abb);
		}
		pr("/%s /%s def\n", ufp->fam[i], getwd());
	}
	while (i < FFAMSIZE)
		ufp->fam[i++] = NULLSTR;
	ufp->next = userfonts;
	userfonts = ufp;
}
