#include	<stdio.h>
#include	"defs.h"
#include	"input.h"
#include	"output.h"
#include	"interpol.h"
#include	"scalenum.h"
#include	"string.h"
#include	"print.h"

#define	WORDSPERLINE	6


void	outword();

static	void	fmt_line();
static	void	do_request();
static	void	outwords();
static	void	copy();
static	void	stripline();
static	void	out_ps_file();

extern	int	centre;
extern	bool	partline, fill, nobreak;


void format(fp, fname)
FILE *fp;
char *fname;
{
	char *prompt = "> ";

	pushinfile(fp, fname);
	while (readline(prompt) == T)
		fmt_line();
}

static void fmt_line()
{
	char c;
	extern void do_changes();

	nobreak = F;
	c = getch();
	if (c == '.' || c == '\'') {
		if (c == '\'')
			nobreak = T;
		do_request();
	} else {
		do_changes();
		stripline();
		if (c == '!') {
			if (peekch() == '!')
				out_ps_file();
			else
				out_ps(getln(REST));
		} else {
			ungetch(c);
			if (fill == F || centre || c == ' ' || c == EOS)
				copy();
			else
				outwords();
		}
	}
}


static void do_request()
{
	char *req;
	void (*request)();
	extern void (*lookup())();
	extern char *trim();

	if (*(req = getwd()) == EOS)	/* discard lines with null request */
		return;
	if ((request = lookup(trim(req)))  == (void (*)())0)
		RET_WARN("no such request");
	(*request)();
}

static void copy()
{
	extern void do_space();

	if (peekch() == EOS) {
		do_space();
		return;
	}
	if (partline == T)
		out_br();
	partline = F;
	if (centre) {
		centre--;
		out_cntr(interpolate(NULLSTR, NULLSTR, NULLSTR, 0));
	} else
		out_line(interpolate(NULLSTR, NULLSTR, NULLSTR, 1), NOT(concatenate));
}

static void outwords()
{
	register char c, *wp;
	char word[1024];
	int n = 0;
	bool inword = F;
	extern int abs_x();
	extern bool get_motion();

	partline = T;
	wp = word;
	while ((c = getch()) != EOS) {
		switch (c) {
		case ' ':
		case '\t':
			break;
		case '\\':
			if ((c = getch()) == 'h')
				break;
			if (c != ' ')
				*wp++ = '\\';
			if (c == '!')
				do
					*wp++ = c;
				while ((c = getch()) != '!' && c != EOS);
		default:
			*wp++ = c;
			inword = T;
			continue;
		}
		if (inword == T) {
			*wp = EOS;
			outword(interpolate(word, NULLSTR, NULLSTR, 0), c==' ', 0);
			wp = word;
			if (++n == WORDSPERLINE) {
				pr("\n");
				n = 0;
			}
		}
		switch (c) {
		case ' ':
			if (inword == F)
				out_space();
			break;
		case '\t':
			out_tab(); break;
		case 'h':
			if (get_motion(72) == F) {
				warn("bad '\\h' expression");
				break;
			}
			if (num.sign == ABS)
				out_ph(abs_x(num.val));
			else
				out_hm(num.sign == MIN ? -num.val : num.val);
			break;
		}
		inword = F;
	}
	if (inword == T) {
		*wp = EOS;
		outword(interpolate(word, NULLSTR, NULLSTR, 0), 1, 1);
		n++;
	}
	if (n)
		pr("\n");
}

void outword(wp, space, eol)
char *wp;
{
	if (space && concatenate == F)
		out_word(wp);
	else
		out_str(wp);
	if (eol && concatenate == F) {
		wp += strlen(wp) - 1;
		while (*wp-- != ')');
		if (*wp == '.' || *wp == '!' || *wp == '?')
			out_space();
	}
}

static void stripline()
{
	register char *l;
	register int len;

	l = getln(ALL);
	len = strlen(l);
	for (l += len - 1; len-- && (*l == ' ' || *l == '\t'); l--)
		*l = EOS;
}


static void out_ps_file()
{
	FILE *psfp;
	char buf[1024];

	(void) getch();
	if (peeknb() == EOS)
		RET_WARN("no file name given with '!!'");
	if ((psfp = fopen(getwd(), "r")) == (FILE *)0)
		RET_WARN("'!!': can't open file for reading");
	(void) putchar('\n');
	while (fgets(buf, 1024, psfp) != (char *)0)
		(void) fputs(buf, stdout);
	(void) fclose(psfp);
}
