#include	"defs.h"
#include	"interpol.h"
#include	"scalenum.h"
#include	"name.h"
#include	"input.h"
#include	"print.h"
#include	"string.h"

#define	dig(c)		((c) >= '0' && (c) <= '9')


bool	concatenate = F;
bool	do_escape_sequ = T;

bool	get_motion();

static	char	fbuf[21];
static	bool	ft_ps;
static	char	*get_char();
static	bool	get_font();
static	bool	get_ps();
static	char	*mk_motion_str();
static	char	*mk_sscript_str();
static	char	*mk_ps_str();
extern	char	*lookup_char();
extern	void	set_local_font();
extern	void	set_local_ps();
extern	char	*current_font();
extern	int	current_vs();


char *interpolate(text, prefont, postfont, horiz_ok)
char *text, *prefont, *postfont;
{
#define	addc(x)		{ if (instr==F) { *sp++ = '('; instr = T; } *sp++ = x; }
#define	closestr()	if (instr==T) { *sp++ = ')'; instr = F; }
#define	addstr(f)	{ *sp=EOS; sp = safebuf + strlen(strcat(safebuf,f)); }
	static char safebuf[4096];
	register char *sp = safebuf, c, d;
	register bool instr = F, textonly = T;
	char *lm;

	*sp++ = '[';
	if (prefont != NULLSTR) {
		addstr(prefont);
		textonly = F;
	}
	if (text)
		pushtempstr(text);
        while (c = getch()) {
		concatenate = F;
                switch (c) {
                case '\\':
			d = peekch();
			if (dig(d)) {
				addc(c);
			} else if (do_escape_sequ == T) {
				switch (d) {
				case 'c':
					concatenate = T;
					/* FALLTHROUGH */
				case '&':
					(void) getch();
					/* FALLTHROUGH */
				case ' ':
					break;
				case 'e':
					(void) getch();
					goto protect;
				case '(':
				case '{':
					if ((lm = get_char()) != NULLSTR) {
						closestr();
						addstr(lm);
						textonly = F;
					}
					break;
				case 'f':
					if (get_font() == T) {
						set_local_font(fbuf, ft_ps);
						closestr();
						addstr(current_font());
						textonly = F;
					} else
						warn("bad \\f sequence");
					break;
				case 's':
					if (get_ps() == T) {
						set_local_ps();
						closestr();
						addstr(current_font());
						textonly = F;
					} else
						warn("bad \\s sequence");
					break;
				case 'h':
					if ((lm = mk_motion_str(1)) != NULLSTR) {
						if (horiz_ok) {
							closestr();
							addstr(lm);
							textonly = F;
						} else
							warn("illegal \\h sequence");
					} else
						warn("bad \\h sequence");
					break;
				case 'v':
					if ((lm = mk_motion_str(0)) != NULLSTR) {
						closestr();
						addstr(lm);
						textonly = F;
					} else
						warn("bad \\v sequence");
					break;
				case 'u':
				case 'd':
					closestr();
					addstr(mk_sscript_str(getch() == 'u'));
					textonly = F;
					break;
				case '!':
					closestr();
					addstr(mk_ps_str());
					textonly = F;
					break;
				case '\\':
					(void) getch();
				default:
					goto protect;
				}
			} else
				goto protect;
			break;
		case '\t':		/* no-fill mode only */
			if (horiz_ok) {
				closestr();
				addstr("{mtab}");
				textonly = F;
			} else
				addc(' ');
			break;
		case '(': case ')':
		protect:
                        addc('\\');
                default:
                        addc(c);
                }
        }
	if (text)
		poptempstr();
	closestr();
	if (postfont != NULLSTR) {
		addstr(postfont);
		textonly = F;
	}
	if (sp[-1] == '[')
		addstr("()");
	if (safebuf[1] != '(' || sp[-1] != ')')
		textonly = F;
	if (textonly == F)
		*sp++ = ']';
        *sp = EOS;
        return textonly == T ? &safebuf[1] : safebuf;
}


static char *get_char()			/* (xx or {X} */
{
	int n;

	n = getch() == '(' ? 2 : 0;
	return lookup_char(trim(getname(n)));
}

static bool get_font()			/* fx or f(xx or f{X[:n]} */
{
	char c, *fp = fbuf;

	ft_ps = F;
	(void) getch();
	if ((c = getch()) != '{') {	/* sequence is \fx or \f(xx */
		if (c == '(') {
			*fp++ = getch();
			*fp++ = getch();
		} else
			*fp++ = c;
		*fp = EOS;
		return T;
	}
	while ((c = getch()) != ':' && c != '}' && c != EOS)
		*fp++ = c;
	*fp = EOS;
	if (c == ':') {
		scale_num(1, T);
		c = getch();
		ft_ps = T;		/* sequence is \f{X:n} */
	}
	if (c != '}')
		return F;
	return ft_ps == T ? NOT(num.err) : T;
}

static bool get_ps()			/* s[+-]n or s([+-]nn or s{N} */
{
	char c;

	(void) getch();
	if ((c = getch()) != '{') {	/* sequence is \s[+-]n or \s([+-]nn */
		bool twodig = F;

		if (c == '(') {
			twodig = T;
			c = getch();
		}
		if (c == '+' || c == '-') {
			num.sign = c == '+' ? PLS : MIN;
			c = getch();
		} else
			num.sign = ABS;
		if (!dig(c))
			return F;
		num.val = c - '0';
		if (twodig == T) {
			c = getch();
			if (!dig(c))
				return F;
			num.val = num.val * 10 + c - '0';
		}
		num.err = F;
	} else {			/* sequence is \s{N} */
		scale_num(1, T);
		if (getch() != '}')
			return F;
	}
	return NOT(num.err);
}


static char *mk_motion_str(horiz)	/* [v|h]'[|]N' */
{
	static char mbuf[64];
	extern int abs_x();

	(void) getch();
	if (get_motion(horiz ? 72 : current_vs()) == F)
		return NULLSTR;
	if (num.sign == ABS) {
		if (horiz)
			(void) sprintf(mbuf, "{%d hp}", abs_x(num.val));
		else
			return NULLSTR;
	} else {
		(void) sprintf(mbuf, "{%s%d", num.sign==MIN ? "-" : "", num.val);
		(void) sprintf(mbuf, "%s %s}", mbuf, horiz ? "rh" : "rv");
	}
	return mbuf;
}

bool get_motion(u)			/* '[|]N' */
{
	char delim;
	bool abs = F;

	delim = getch();
	if (peeknb() == '|') {
		(void) getnb();
		abs = T;
	}
	scale_num(u, T);
	if (getch() != delim || num.err == T)
		return F;
	if (abs == T)
		num.sign = ABS;
	else if (num.sign == ABS)
		num.sign = PLS;
	return T;
}

static char *mk_sscript_str(up)
{
	static char sbuf[64];

	(void) sprintf(sbuf, "{%s%d rv}", up ? "-" : "", current_vs() / 2);
	return sbuf;
}

static char *mk_ps_str()		/* !PS! */
{
	static char buf[1024];
	register char *bp = buf, c;

	(void) getch();
	*bp++ = '{';
	while ((c = getch()) != '!' && c != EOS)
		*bp++ = c;
	*bp++ = '}';
	*bp = EOS;
	return buf;
}
