#include	"instruct.h"
#include	"print.h"
#include	<setjmp.h>

#define	STACKSIZE	1000


static	float	stack[STACKSIZE];	/* the stack machine */
static	float	*tos;			/* top-of-stack pointer */

extern	instr	code[];			/* the code to interpret */
extern	float	t_data[];		/* temp data space */

static	void	push();
static	double	pop();
static	void	rterr();


double interpret()
{
	register instr *s;
	float op1, op2;
	
	tos = stack;
	for (s = code; *s != EOCODE; s++) {
		switch (*s) {
		case LOAD:
			push(t_data[*++s]);
			continue;
		case UMIN:
			push((float)-pop());
			continue;
		}
		op2 = (float)pop();
		op1 = (float)pop();
		switch (*s) {
		case AND:
			push((float)((int)op1 && (int)op2)); break;
		case OR:
			push((float)((int)op1 || (int)op2)); break;
		case MOD:
			push((float)((int)op1 % (int)op2)); break;
		case EQ:
			push((float)(op1 == op2)); break;
		case NE:
			push((float)(op1 != op2)); break;
		case LT:
			push((float)(op1 < op2)); break;
		case LE:
			push((float)(op1 <= op2)); break;
		case GT:
			push((float)(op1 > op2)); break;
		case GE:
			push((float)(op1 >= op2)); break;
		case ADD:
			push(op1 + op2); break;
		case SUB:
			push(op1 - op2); break;
		case MUL:
			push(op1 * op2); break;
		case DIV:
			if (op2 == 0.0)
				rterr("division be zero");
			push(op1 / op2); break;
		default:
			rterr("illegal instruction");
		}
	}
	return pop();
}


static void push(x)
float x;
{
	if (tos >= &stack[STACKSIZE])
		rterr("stack overflow");
	*tos++ = x;
}

static double pop()
{
	if (--tos < stack)
		rterr("stack underflow");
	return (double)*tos;
}

static void rterr(s)
char *s;
{
	char ebuf[100];
	extern jmp_buf ejbuf;

	(void) sprintf(ebuf, "%s during expression evaluation", s);
	warn(ebuf);
	longjmp(ejbuf, 1);
}
