#include	"defs.h"
/*
 * scan a string; return True if legal syntax for float.
 *
 * float ::= [+|-] <simple_float> [(e|E) [+|-] <uns_int> ]
 * simple_float ::= ( <uns_int> [. <uns_int>] ) | ( . <uns_int> )
 * uns_int ::= digit { digit }
 */

#define digit(c)	(c >= '0' && c <= '9')
#define skipdig		while (digit(*s)) { ndig++; s++; }
#define skipsign	if (*s == '-' || *s == '+') s++;
#define expon(c)	(c == 'e' || c == 'E')
#define skipblank	while (*s == ' ' || *s == '\t') s++;
#define assert(cond)	if (!(cond)) return F;

bool isfloat(s)
register char *s;
{
	register ndig;

	skipblank; skipsign; ndig=0;
	skipdig;
	if (*s == '.'){
		s++; skipdig;
	}
	assert(ndig > 0);
	if (expon(*s)){
		s++; skipsign;
		ndig = 0; skipdig; assert(ndig > 0);
	}
	skipblank; assert(*s == EOS);
	return T;
}
