#include	"defs.h"
#include	"input.h"
#include	"string.h"
#include	"print.h"
#include	"alloc.h"

#define	MAXARGS	9


typedef struct A {
	char	*arg[MAXARGS];
	int	nargs;
	struct A *last;
} arglist;

static	arglist	*curargs = (arglist *)0;
static	char	*get_arg();

extern	void	set_ireg();


void push_args()
{
	register arglist *ap;
	int i = 0;

	ap = (arglist *)alloc(sizeof(*ap), "macro arguments");
	while (peeknb() != EOS && i < MAXARGS) {
		get_string();
		ap->arg[i++] = mk_string(string);
	}
	ap->nargs = i;
	while (i < MAXARGS)
		ap->arg[i++] = NULLSTR;
	ap->last = curargs;
	curargs = ap;
	set_ireg(".$", ap->nargs);
}

void pop_args()
{
	register arglist *ap = curargs;
	int i;

	if (ap == (arglist *)0) {
		pr("*** pop_args called with empty arglist stack\n");
		return;
	}
	for (i = 0; i < MAXARGS && ap->arg[i]; i++)
		free(ap->arg[i]);
	curargs = ap->last;
	free((char *)ap);
	set_ireg(".$", curargs == (arglist *)0 ? 0 : curargs->nargs);
}

void interp_arg()		/* \$n */
{
	char c, *arg;

	c = getch();
	if (c < '1' || c > '9') {
		ungetch(c);
		return;
	}
	if ((arg = get_arg(c - '0')) != NULLSTR)
		pushinstr(arg);
}

static char *get_arg(n)
{
	if (curargs == (arglist *)0)
		return NULLSTR;
	return curargs->arg[n-1];
}
