#include	"defs.h"
#include	"print.h"
#include	"alloc.h"


typedef	struct { short	first, last; }	pagerange;

static	pagerange	*pagelist = (pagerange *)0;
static	unsigned	listlen;

static	void	make_list();
static	void	print_list();
static	int	compare();


void do_pagelist(list)
char *list;
{
	if (list)
		make_list(list);
	else
		print_list();
}

static void make_list(userlist)
char *userlist;
{
	register char *p, *q, *r;
	register pagerange *plp;
	extern char *strchr();
	extern void qsort();
	extern int atoi();

	if (pagelist != (pagerange *)0)
		free((char *)pagelist);
	/* count # elements in comma-separated list */
	for (p = userlist, listlen = 1; q = strchr(p, ','); p = q+1)
		listlen++;
	plp = pagelist = (pagerange *)alloc(listlen * sizeof(pagerange),
			"user page list");
	/* split the list into elements 'n' or 'n-m'.
	   recount in case of "bad" elements */
	listlen = 0;
	for (p = userlist; p && *p; p = q) {
		if ((q = strchr(p, ',')) != 0)
			*q++ = '\0';
		if ((r = strchr(p, '-')) != 0) {
			*r++ = '\0';
			plp->first = (short)atoi(p);
			plp->last = *r ? (short)atoi(r) : (short)0; /* 0 => EOF */
			if (plp->first > plp->last && plp->last != 0)
				ferr("bad range in '-o' option\n", NULLSTR);
		} else
			plp->first = plp->last = (short)atoi(p);
		if (plp->first < 0 || plp->last < 0)
			ferr("bad number in '-o' option\n", NULLSTR);
		listlen++;
		plp++;
	}
	/* sort the list on first element 'n' */
	qsort((char *)pagelist, listlen, sizeof(pagerange), compare);
}


static int compare(r1, r2)
pagerange *r1, *r2;
{
	if (r1->first < r2->first)
		return -1;
	if (r1->first > r2->first)
		return 1;
	return 0;
}


static void print_list()
{
	unsigned i, teof = 0, hi = 0;
	register pagerange *plp;

	if (pagelist == (pagerange *)0) {	/* no page list */
		pr("/@pli -1 def\n");
		return;
	}
	/* output the list. remove 'embedded' page numbers.
	   recount for "bad" or removed elements */
	i = listlen; listlen = 0;
	pr("/@pl[");
	for (plp = pagelist; teof == 0 && i--; plp++) {
		if (plp->first == 0)
			continue;
		if (plp->first == plp->last) {
			if (plp->first > hi) {
				pr("[%d]", hi = plp->first);
				listlen++;
			}
		} else {
			if (plp->last && plp->last <= hi)
				continue;
			pr("[%d", plp->first > hi ? hi = plp->first : ++hi);
			listlen++;
			if (plp->last == 0)
				teof = 1;
			else if (hi < plp->last)
				pr(" %d", hi = plp->last);
			pr("]");
		}
	}
	if (listlen == 0)
		ferr("unusable argument with '-o' option\n", NULLSTR);
	pr("]def\n");
	pr("/@pli 0 def/@pll %d def/@pteof? @%c def\n", listlen, teof?'T':'F');
	free((char *)pagelist);
}
